﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1 {
    class Program {
        static void Main(string[] args) {
            string textcode = System.IO.File.ReadAllText("SampleScript.txt");
            //^Read the text containing the Cielo Explorer script to compile and execute
            
            APLNext.CieloInteractive.Hosting.APLEngine aplEngine = new APLNext.CieloInteractive.Hosting.APLEngine();
            //^Create an instance of the VisualAPL APLEngine class

            object objectcode = aplEngine.Compile(textcode);
            //^Use the Compile() method of the APLEngine class on the Cielo Explorer script

            aplEngine.Execute(objectcode);
            //^Use the Execute() method of the APLEngine class on the compiled Cielo Explorer script

            object res;
            //^Create an instance of the object class to contain the results of the methods in the
            // Cielo Explorer script. The object datatype is used because the Cielo Explorer script
            // methods were written to not statically-type their results.

            res = aplEngine.Evaluate("add(10,20)");
            //^Use the Evaluate() method of the APLEngine to execute the add(,) method of the
            // Cielo Explorer script on scalar arguments
            Console.WriteLine(res.ToString());

            aplEngine.SetVariable("d", new int[] { 10, 20, 30 });
            //^Define the array variable d within the compiled and executed instance of the
            // Cielo Explorer script.

            int[] myVar = new int[] {5, 10, 15};
            aplEngine.SetVariable("e", myVar);
            //^It is also possible to define the array variable 'e' in the compiled and executed
            // instance of the Cielo Explorer script using a C# variable [of applicable type].

            res = aplEngine.Evaluate("minus(d,e)");
            //^Use the Evaluate() method of the APLEngine to execute the minus(,) method of the
            // Cielo Explorer script on array arguments.
            foreach (int i in (int[])res)
            {
                Console.WriteLine(i.ToString());
            }

            res = aplEngine.Evaluate("1+1");
            //^It is also possible to use the Evaluate() method of the APLEngine to directly
            // preform calculations
            Console.WriteLine(res.ToString());
            
            aplEngine.Execute("a = 1 2 3 4");
            object a = aplEngine.GetVariable("a");
            //^The Execute() method of the APLEngine can also directly execute VisualAPL text expressions
            Console.WriteLine(((int[])a)[0].ToString());

            Console.ReadLine();
            //^Wait for user to close the Console window after observing results
        }
    }
}